//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: kava/liquid/v1beta1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query defines the gRPC querier service for liquid module
///
/// Usage: instantiate `Kava_Liquid_V1beta1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Kava_Liquid_V1beta1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Kava_Liquid_V1beta1_QueryClientInterceptorFactoryProtocol? { get }

  func delegatedBalance(
    _ request: Kava_Liquid_V1beta1_QueryDelegatedBalanceRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Kava_Liquid_V1beta1_QueryDelegatedBalanceRequest, Kava_Liquid_V1beta1_QueryDelegatedBalanceResponse>
}

extension Kava_Liquid_V1beta1_QueryClientProtocol {
  internal var serviceName: String {
    return "kava.liquid.v1beta1.Query"
  }

  /// DelegatedBalance returns an account's vesting and vested coins currently delegated to validators.
  /// It ignores coins in unbonding delegations.
  ///
  /// - Parameters:
  ///   - request: Request to send to DelegatedBalance.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func delegatedBalance(
    _ request: Kava_Liquid_V1beta1_QueryDelegatedBalanceRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Kava_Liquid_V1beta1_QueryDelegatedBalanceRequest, Kava_Liquid_V1beta1_QueryDelegatedBalanceResponse> {
    return self.makeUnaryCall(
      path: "/kava.liquid.v1beta1.Query/DelegatedBalance",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeDelegatedBalanceInterceptors() ?? []
    )
  }
}

internal protocol Kava_Liquid_V1beta1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'delegatedBalance'.
  func makeDelegatedBalanceInterceptors() -> [ClientInterceptor<Kava_Liquid_V1beta1_QueryDelegatedBalanceRequest, Kava_Liquid_V1beta1_QueryDelegatedBalanceResponse>]
}

internal final class Kava_Liquid_V1beta1_QueryClient: Kava_Liquid_V1beta1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Kava_Liquid_V1beta1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the kava.liquid.v1beta1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Kava_Liquid_V1beta1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query defines the gRPC querier service for liquid module
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Kava_Liquid_V1beta1_QueryProvider: CallHandlerProvider {
  var interceptors: Kava_Liquid_V1beta1_QueryServerInterceptorFactoryProtocol? { get }

  /// DelegatedBalance returns an account's vesting and vested coins currently delegated to validators.
  /// It ignores coins in unbonding delegations.
  func delegatedBalance(request: Kava_Liquid_V1beta1_QueryDelegatedBalanceRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Kava_Liquid_V1beta1_QueryDelegatedBalanceResponse>
}

extension Kava_Liquid_V1beta1_QueryProvider {
  internal var serviceName: Substring { return "kava.liquid.v1beta1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "DelegatedBalance":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Kava_Liquid_V1beta1_QueryDelegatedBalanceRequest>(),
        responseSerializer: ProtobufSerializer<Kava_Liquid_V1beta1_QueryDelegatedBalanceResponse>(),
        interceptors: self.interceptors?.makeDelegatedBalanceInterceptors() ?? [],
        userFunction: self.delegatedBalance(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Kava_Liquid_V1beta1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'delegatedBalance'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeDelegatedBalanceInterceptors() -> [ServerInterceptor<Kava_Liquid_V1beta1_QueryDelegatedBalanceRequest, Kava_Liquid_V1beta1_QueryDelegatedBalanceResponse>]
}
